QgsMapLayer::dataChanged not emited when QgsVectorLayer data are modified

2016-03-14 11:28 AM - Vincent Mora

Status: Closed

Priority: Normal

Assignee:

Category: Data Provider

Affected QGIS version:2.8.3 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: end of life

Crashes QGIS or corrupts data:No Copied to github as #: 22466

Description

To reproduce activate a vector layer, and in the in the python console:

def prt():

    print "changed" 

iface.activeLayer().dataChanged.connect(prt)

Open the attribute table and change an attribute, save -> nothing

iface.activeLayer().editingStopped.connect(prt)

Works instead, but it's not really the first thing that comes to mind (actually it only came to mine by looking at

QgsVectorLayer::commitChanges source code).

History

#1 - 2016-04-09 10:03 AM - Giovanni Manghi

- Category set to Python plugins

#2 - 2016-07-11 08:54 AM - Hugo Mercier

- Status changed from Open to Feedback

- Category changed from Python plugins to Data Provider

Indeed. Also observed on 2.15

Actually, this dataChanged signal seems to be used only on setSubsetString() of each provider ...

There is also a layerModified signal which is only emitted when attribute aliases are created or removed ...

A "something has changed" signal (for feature addition/removal/modification) could be helpful.

What about choosing only one signal and emitting it when one of the other modification signals is emitted ? (maybe for qgis 3.0)

#3 - 2017-01-02 08:17 AM - Giovanni Manghi

- Status changed from Feedback to Open

#4 - 2017-05-01 01:05 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#5 - 2019-03-09 03:12 PM - Giovanni Manghi
- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

2025-05-18 2/2

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

